//+------------------------------------------------------------------+ 
//|   TRO_3Trigger                                                   | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|   All my indicators should be considered donationware. That is   |
//|   you are free to use them for your personal use, and are        |
//|   under no obligation to pay for them. However, if you do find   |
//|   this or any of my other indicators help you with your trading  |
//|   then any Gift or Donation as a show of appreciation is         |
//|   gratefully accepted.                                           |
//|                                                                  |
//|   Gifts or Donations also keep me motivated in producing more    |
//|   great free indicators. :-)                                     |
//|                                                                  |
//|   PayPal - THERUMPLEDONE@GMAIL.COM                               |  
//+------------------------------------------------------------------+ 

#property indicator_chart_window 
#property indicator_buffers 2 
#property indicator_color1 Orange 
#property indicator_color2 Blue 
 

//---- input parameters 

extern bool   Sound.Alert  = true ;
extern bool   Plot.Alert   = true ;
extern bool   Show.Box     = true ; 
extern int    myBoxWidth   = 3;

extern double    iAlertShortLevel = 0.85; 
extern double    iAlertBuyLevel   = 0.15; 




extern int myWingDing  = 119 ;
extern   int      max_bars=300; 


extern int       iPeriods=1; 
extern int       iShift =1; 


//---- buffers 
double DynR[]; 
double DynS[]; 


string tShort0 = "Res_0" ;
string tLong0 = "Sup_0" ;
 
string tAlertBuy ="Buy_sr"  ; 
string tAlertShort = "Short_sr"; 

datetime Trigger ;

double    iAlertBuy   ; 
double    iAlertShort; 
 
string symbol, tChartPeriod,  tShortName ;  
int    digits, period  ; 
//+------------------------------------------------------------------+ 
//| Custom indicator initialization function                         | 
//+------------------------------------------------------------------+ 
int init() 
  { 
//---- indicators 
   SetIndexStyle(0,DRAW_ARROW); 
   SetIndexArrow(0,myWingDing); 
   SetIndexBuffer(0,DynR); 
   SetIndexEmptyValue(0,0.0); 
   SetIndexStyle(1,DRAW_ARROW); 
   SetIndexArrow(1,myWingDing); 
   SetIndexBuffer(1,DynS); 
   SetIndexEmptyValue(1,0.0); 
 
   
   period = Period();  
   tChartPeriod =  TimeFrameToString(period) ;
   symbol       =  Symbol() ;   
   digits       =  Digits ;   
   Trigger      =  Time[0] ;  
//---- 
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| Custom indicator deinitialization function                       | 
//+------------------------------------------------------------------+ 
int deinit() 
  { 

   ObjectDelete(tShort0); 
   ObjectDelete(tLong0); 
 
   return(0); 
  } 
//+------------------------------------------------------------------+ 
//| Custom indicator iteration function                              | 
//+------------------------------------------------------------------+ 
int start() 
  { 
   int    counted_bars=IndicatorCounted(); 
    if(counted_bars < 0) 
        return(-1); 
//---- 
   int limit=Bars-counted_bars; 
    
   DynR[0] = Close[0]; 
   DynS[0] = Close[0]; 

   double nHH, nLL; 
   double range; 

   int processBars=MathMin(limit, max_bars); 
   for(int i=processBars;i>=0;i--)
   { 
      range   = High[i+iShift] - Low[i+iShift]; 


      DynR[i] = Low[i+iShift] + range * iAlertShortLevel ;
      DynS[i] = Low[i+iShift] + range * iAlertBuyLevel ;             


   } //end for 

      iAlertBuy    = DynS[iShift]  ;
      iAlertBuy    = NormalizeDouble( iAlertBuy , digits ) ; 
 
      iAlertShort  = DynS[iShift]  ; 
      iAlertShort  = NormalizeDouble( iAlertShort , digits ) ; 

      if ( Trigger != Time[0] &&  Sound.Alert ) 
      {
        if( Ask >= iAlertBuy   && Low[0] <= iAlertBuy )  { Trigger = Time[0] ; Alert(symbol,"  ", tChartPeriod, DoubleToStr(iAlertBuy ,digits), " DYN SR Buy  " ); }
        if( High[0] >= iAlertShort && Bid <= iAlertShort) { Trigger = Time[0]  ; Alert(symbol,"  ", tChartPeriod,  DoubleToStr(iAlertShort ,digits), " DYN SR Short "); }     
      }

     




         
//---- 

   DoBoxes() ;

   WindowRedraw() ;
   return(0); 
  } 
//+------------------------------------------------------------------+ 


void DoBoxes()
{

  if (ObjectFind(tShort0) != 0)
      {
          ObjectCreate(tShort0,OBJ_ARROW,0,Time[0],DynR[0]);
          ObjectSet(tShort0,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tShort0,OBJPROP_COLOR,indicator_color1);  
          ObjectSet(tShort0,OBJPROP_WIDTH,myBoxWidth);
      } 
      else
      {
         ObjectMove(tShort0,0,Time[0],DynR[0]);
      }

  if (ObjectFind(tLong0) != 0)
      {
          ObjectCreate(tLong0,OBJ_ARROW,0,Time[0],DynS[0]);
          ObjectSet(tLong0,OBJPROP_ARROWCODE,SYMBOL_RIGHTPRICE);
          ObjectSet(tLong0,OBJPROP_COLOR,indicator_color2);  
          ObjectSet(tLong0,OBJPROP_WIDTH,myBoxWidth);  
      } 
      else
      {
         ObjectMove(tLong0,0,Time[0],DynS[0]);
      }

}

//+--------- TRO MODIFICATION ---------------------------------------+  

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}


//+--------- TRO MODIFICATION ---------------------------------------+  


/*
Alert(  DoubleToStr(iAlertShort ,digits), " DYN SR Short ");

Comment(


"High[0]= ",    DoubleToStr(High[0] ,digits) , "\n",
"iAlertShort= ",    DoubleToStr(iAlertShort ,digits) , "\n",
"Bid= ",    DoubleToStr(Bid ,digits) , "\n",
"Low[0]= ",    DoubleToStr(Low[0] ,digits) , "\n",
" ",    "\n",

"High[0]= ",    DoubleToStr(High[0] ,digits) , "\n",
"Ask= ",    DoubleToStr(Ask ,digits) , "\n",
"iAlertBuy= ",    DoubleToStr(iAlertBuy ,digits) , "\n",
"Low[0]= ",    DoubleToStr(Low[0] ,digits) , "\n",


"") ; 

*/